require 'sketchup.rb'
require 'extensions.rb'
require 'socket.so'

module SimTools
	$initialized = false

	def self.readData(socket)
		data = nil
		begin
		sender = socket.recvfrom_nonblock(100)[0]
		rescue Exception => msg
			# puts msg
		end
		data = sender
		return data
	end
	
	def self.updateView(axisArray)
		$axis1, $axis2, $axis3, $axis4, $axis5, $axis6 = axisArray
	end
	
	def self.printData(axisArray)
		printf "(Axis1: %f, Axis2: %f, Axis3: %f, Axis4: %f, Axis5: %f, Axis6: %f)}\n", axisArray[0], axisArray[1], axisArray[2], axisArray[3], axisArray[4], axisArray[5]
	end
	
	def self.calcAxis(data)
		message1, message2, message3, message4, message5, message6 = data.split(";")
		newAxis1 = message1.to_f / 256.0
		newAxis2 = message2.to_f / 256.0
		newAxis3 = message3.to_f / 256.0
		newAxis4 = message4.to_f / 256.0
		newAxis5 = message5.to_f / 256.0
		newAxis6 = message6.to_f / 256.0

		return arr = [newAxis1, newAxis2, newAxis3, newAxis4, newAxis5, newAxis6]
	end

	
	def self.startTimer(socket)
		timer_id = UI.start_timer(0.01, true) {
			data = self.readData(socket)
			if data
				axisArray = self.calcAxis(data)
				self.updateView(axisArray)
				self.printData(axisArray)
			end
		}
		return timer_id
	end

	def self.init
	    begin
			if $initialized
				puts "SimTools is already running"
				return
			end
				timer_id = nil
				socket = UDPSocket.new
				socket.bind("127.0.0.1", 3157)
				$initialized = true
				timer_id = self.startTimer(socket)
		rescue Exception => msg  
			puts msg  
		end
	end

	
    unless file_loaded?(__FILE__)
	  menu = UI.menu('Plugins')
	  menu.add_item('SimTools - Connect to Port 3157') {
		self.init
	  }
	  file_loaded(__FILE__)
    end
	
end # module SimTools